<script>
import Vue from "vue";
import ElarStattimeSlider from "./ElarStatTimeSlider.vue";
const ElarStattimeSliderCtor = Vue.extend(ElarStattimeSlider);
import ElarStat2ndComp from "./ElarStat2ndComp.vue";
const ElarStat2ndCompCtor = Vue.extend(ElarStat2ndComp);
export default {
  name: "ComponentChooser",
  computed: {
    serviceList: function () {
      return Object.keys(this.service2Choose);
    },
  },
  data() {
    return {
      selectedService: null,
      selectedServices: [],
      createdComponents: {},
      title: null,
      service2Choose: {
        Paritetici: {
          title: "Servizio contributo paritetici",
          A42: 35,
        },
        Rendite: {
          title: "Rendite",
          A42: 11,
        },
        AssegniFamiliari: {
          title: "Assegni Familiari",
          A42: 55,
        },
      },
      components2create: [
        {
          component: "ElarStattimeSlider",
          compParam: {
            divId: "div1",
            url_request_path: "/nbr_prat_per_date_and_da_spec",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di Pratiche per processo",
            plotly_type: "line",
            column_key: "A43",
            x_column: "MY_DATE",
            y_column: "NBR_QUERIES",
          },
        },
        {
          component: "ElarStat2ndComp",
          compParam: {
            divId: "div2",
            url_request_path: "/nbr_op_per_coll_and_da_spec_param_date",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di operazione per processo e collaboratore",
            plotly_type: "bar",
            column_key: "A43",
            x_column: "B_NAME",
            y_column: "NBR_QUERIES",
          },
        },
        {
          component: "ElarStat2ndComp",
          compParam: {
            divId: "div3",
            url_request_path: "/nbr_op_per_da_spec_and_doc_type_param_date",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di operazione per processo e tipo di documento",
            plotly_type: "bar",
            column_key: "A43",
            x_column: "DOC_TYPE",
            y_column: "NBR_QUERIES",
          },
        },
      ],
    };
  },
  methods: {
    serviceChanged() {
      let initId = "containerId";
      console.log("-----selected service = ", this.selectedService);
      if (!this.selectedServices.includes(this.selectedService)) {
        this.selectedServices.push(this.selectedService);
      }

      let serviceParam = this.service2Choose[this.selectedService];

      let componentParam = this.components2create[0].compParam;
      let allParameters = { ...serviceParam, ...componentParam };
      const ElarStattimeSliderInstance = new ElarStattimeSliderCtor({ propsData: allParameters });
      ElarStattimeSliderInstance.$mount("#containerId1");

      componentParam = this.components2create[1].compParam;
      allParameters = { ...serviceParam, ...componentParam };
      let componentInstance = new ElarStat2ndCompCtor({ propsData: allParameters });
      componentInstance.$mount("#containerId2");

      componentParam = this.components2create[2].compParam;
      allParameters = { ...serviceParam, ...componentParam };
      componentInstance = new ElarStat2ndCompCtor({ propsData: allParameters });
      componentInstance.$mount("#containerId3");
    },
  },
};
</script>
<template>
  <div id="app">
    <v-app>
      <v-app-bar app>
        <label for="services">Choose a Service</label>
        <v-row justify="center" class="ma-2">
          <v-col sm="6">
            <v-select v-bind:items="serviceList" v-model="selectedService" v-on:change="serviceChanged" />
          </v-col>
        </v-row>
      </v-app-bar>
      <v-main>
        <v-container v-for="service in serviceList" v-bind:key="service" v-bind:id="service" v-is>          
            <v-row  v-for="service in serviceList" v-bind:key="service" v-bind:id="service">
            <v-col  v-bind:id="service">
              {{service2Choose[service].title}}
            </v-col>
          </v-row>       
        </v-container>
      </v-main>
    </v-app>
  </div>
</template>
